.486
.model flat, stdcall
option casemap: none

; API functions
; ------------------------------------------------------------------------------
include  \masm32\include\windows.inc
include  \masm32\include\user32.inc
include  \masm32\include\kernel32.inc
include  \masm32\include\comctl32.inc
include  \masm32\include\comdlg32.inc

includelib  \masm32\lib\user32.lib
includelib  \masm32\lib\kernel32.lib
includelib  \masm32\lib\comctl32.lib
includelib  \masm32\lib\comdlg32.lib
; ------------------------------------------------------------------------------

; Prototype 
; ------------------------------------------------------------------------------
DialogProc PROTO : HWND, : UINT, : WPARAM, : LPARAM

.const

; Resource ids
; ------------------------------------------------------------------------------
IDD_DLG1  	  equ 101
IDC_EXIT      equ 102
IDC_TEXT      equ 103
IDC_EDT1      equ 104
IDC_EDT2      equ 105
IDI_ICON      equ 200

; Required data

.data
szTitle       TCHAR 'TEST Edit Box window', 0
szError				TCHAR 'Please type some text',0
szErrortitle  TCHAR 'Error',0
Message    db   'Caps lock on !!!',0
Caption    db   'Warning',0
.data?
hInstance HINSTANCE ?
hIcon     HICON     ?
hEdit1				dd ?
hEdit2				dd ?

.code

start:

INVOKE InitCommonControls

INVOKE GetModuleHandle, NULL
mov hInstance, eax

INVOKE LoadIcon, eax, IDI_ICON 
mov hIcon, eax

INVOKE DialogBoxParam, hInstance, IDD_DLG1 , NULL, ADDR DialogProc, 0
INVOKE ExitProcess, 0


; Dialog procedure
; ------------------------------------------------------------------------------
DialogProc proc hWnd: HWND, uMsg: UINT, wParam: WPARAM, lParam: LPARAM
LOCAL buffer[128]:BYTE	;our local variable, like ---> Dim buffer as string
Mov		eax, uMsg
 .IF eax == WM_INITDIALOG
 INVOKE SetTimer,hWnd ,0,90, 0	; Set The Timer	
  INVOKE SetWindowText, hWnd, addr szTitle 
  INVOKE SendMessage, hWnd, WM_SETICON,ICON_SMALL, hIcon
  	; initialising our 2 editboxes
  INVOKE GetDlgItem,hWnd,104	;Windows API result gets stored in eax
	mov hEdit1,eax				;assembler OPCODE stored flag flag from eax moved to hEdit1	
  ;INVOKE SetFocus,hEdit1			;Windows API
  
  INVOKE GetDlgItem,hWnd,105
	mov hEdit2,eax
	INVOKE SetFocus,hEdit2
; NOTE: if we 	"INVOKE SetFocus,hEdit2" as well than when the .exe opens the curser will be flashing 
; and ready to recive text in the second edit box insted of the first - there can only be one box with "setfocus"
; it can be any Edit Box  we want !


    .ELSEIF eax == WM_COMMAND
;--------------------------- Dose Not Work ??? --------------------

      INVOKE GetKeyState, VK_CAPITAL	;was Caps Lock pressed?
       .IF uMsg == WM_TIMER   
 .ELSEIF eax != 0 ;if yes
 INVOKE MessageBox, hWnd, offset Message, offset Caption, MB_ICONWARNING 	;call our Messagbox
  .ENDIF	
;-------------------------------------------------------------------
      .ELSEIF uMsg == WM_CLOSE
    INVOKE EndDialog, hWnd, 0
 .ENDIF

      .IF wParam == IDC_TEXT
  ;first we check if the user has inserted any text
			;if so we copy it to the second textbox
			invoke GetWindowTextLength,hEdit1		;Win API result gets stored in the eax register

			cmp eax,0							;Assembler OPCODE to compare 
			je @F								;Jump if equal to 0 to @@:
  
;  INVOKE GetKeyState,VK_CAPITAL ;is Caps Lock on?
;   .IF uMsg == WM_TIMER 
   
; .ELSEIF eax != 0 ;if yes
; INVOKE MessageBox, hWnd, offset Message, offset Caption, MB_ICONWARNING 	;call our Messagbox
;  .ENDIF	  

			;ok here we get only if user has typed some text
			invoke SendMessage,hEdit1,WM_GETTEXT,sizeof buffer,addr buffer  ;here is where we use our local variable

			invoke SendMessage,hEdit2,WM_SETTEXT,0,addr buffer			;the stored string in eax gets copied to editbox 2
			 
			
			
				jmp Exit						;Assembler OPCDOE jmp means jump now to (Exit)
			@@:								;here is where we came from je @F (User didnt enter any text) also @F means jump forward @B would be jump back :)
			invoke MessageBox,hWnd,offset szError,offset szErrortitle ,MB_ICONINFORMATION
			Exit:			;We exit the Messageloop here
			.ENDIF
		
  
  .IF wParam == IDC_EXIT 
      INVOKE SendMessage, hWnd, WM_CLOSE, 0, 0

    .ENDIF

    xor eax,eax
  ret
DialogProc endp

end start