.386
.model flat, stdcall  ;32 bit memory model
option casemap :none  ;case sensitive

include \masm32\include\windows.inc
include \masm32\include\user32.inc
include \masm32\include\kernel32.inc
include  \masm32\include\masm32.inc
include  \masm32\include\comctl32.inc

includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib
includelib  \masm32\lib\masm32.lib
includelib  \masm32\lib\comctl32.lib

DlgProc PROTO : HWND, : UINT, : WPARAM, : LPARAM

.const
IDD_DIALOG1 equ 101
IDI_ICON  equ 200

.data
szTitle       TCHAR "Key state Example", 0
Message    db   "Caps Lock was pressed!!",0
Caption    db   "Messagebox Title",0
.data?

hInstance HINSTANCE ?
hIcon     HICON     ?

.code

start:
INVOKE InitCommonControls
INVOKE GetModuleHandle,NULL
mov		hInstance,eax
INVOKE LoadIcon, eax, IDI_ICON 
mov hIcon, eax

INVOKE DialogBoxParam,hInstance,IDD_DIALOG1,NULL,addr DlgProc,NULL
INVOKE ExitProcess,0

;########################################################################

DlgProc proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

	mov		eax,uMsg
	.IF eax==WM_INITDIALOG
	       
	      INVOKE SetWindowText, hWin, addr szTitle 
		  INVOKE SendMessage, hWin, WM_SETICON,ICON_SMALL, hIcon
		  INVOKE SetTimer,hWin,0,90, 0					; Set The Timer
		  .ELSEIF uMsg == WM_TIMER
   
     INVOKE GetAsyncKeyState, VK_CAPITAL ;WAS Caps Lock on pressed?
      .IF eax != 0										;if yes
          INVOKE MessageBox, hWin, offset Message, offset Caption, MB_OK 	;call our Messagbox
      .ENDIF
      ret
	.ELSEIF eax==WM_COMMAND

	.ELSEIF eax==WM_CLOSE
		INVOKE EndDialog,hWin,0
	.ELSE
		mov		eax,FALSE
		ret
	.ENDIF
	mov		eax,TRUE
	ret

DlgProc endp

end start
