.486
.model flat, stdcall
option casemap: none

; API functions
; ------------------------------------------------------------------------------
include  \masm32\include\windows.inc
include  \masm32\include\user32.inc
include  \masm32\include\kernel32.inc
include  \masm32\include\comctl32.inc
include  \masm32\include\masm32.inc
include  \masm32\include\gdi32.inc 
include  \masm32\include\shell32.inc


includelib  \masm32\lib\user32.lib
includelib  \masm32\lib\kernel32.lib
includelib  \masm32\lib\comctl32.lib
includelib  \masm32\lib\masm32.lib
includelib  \masm32\lib\gdi32.lib 
includelib  \masm32\lib\shell32.lib
include 	\masm32\include\msimg32.inc
includelib 	\masm32\lib\msimg32.lib
; ------------------------------------------------------------------------------

; Prototype 
; ------------------------------------------------------------------------------
DialogProc PROTO : HWND, : UINT, : WPARAM, : LPARAM

.const
; Resource ids
; ------------------------------------------------------------------------------
IDD_DLG1  	   equ 101
IDI_ICON       equ 200

; Required data

.data



.data?
hInstance HINSTANCE ?
hIcon     HICON     ?
ResInf			dd		?
ResDat			dd		?
ResSize	    	dd		?
RGNRes			dd		?
Brush			dd		?
.code

start:

invoke GetModuleHandle, NULL 
mov hInstance,eax 
invoke DialogBoxParam,hInstance,IDD_DLG1,NULL,addr DialogProc,NULL 
invoke ExitProcess,eax 
    
; Dialog procedure
; ------------------------------------------------------------------------------
DialogProc proc hWnd: HWND, uMsg: UINT, wParam: WPARAM, lParam: LPARAM

	
Mov		Eax, uMsg
	.If 	Eax == WM_INITDIALOG
   invoke GetWindowLong,hWnd,GWL_EXSTYLE 
	
	invoke SetWindowLong,hWnd,GWL_EXSTYLE,eax 
	invoke SetWindowPos,hWnd,HWND_TOPMOST,0,0,0,0,SWP_NOMOVE+SWP_NOSIZE
	invoke LoadBitmap,hInstance,300          
	invoke CreatePatternBrush,eax
	mov Brush,eax
	invoke FindResource,hInstance,301,RT_RCDATA
	mov ResInf,eax
	invoke LoadResource,hInstance,ResInf
	mov ResDat,eax
	invoke SizeofResource,hInstance,ResInf
	mov	ResSize,eax
	invoke LockResource,ResDat
	mov RGNRes,eax
	invoke ExtCreateRegion,NULL,ResSize,RGNRes
	invoke SetWindowRgn,hWnd,eax,TRUE
	invoke LoadIcon,hInstance,IDI_ICON		
	invoke SendMessage,hWnd,WM_SETICON,1,eax
	
	
	invoke ShowWindow,hWnd,SW_SHOW
	
 .elseif uMsg==WM_CTLCOLORDLG ; This paint the bitmap image on the region
	mov eax, Brush
	ret		
.ElseIf eax == WM_LBUTTONDOWN
		invoke SendMessage, hWnd, WM_NCLBUTTONDOWN,HTCAPTION, 0
	;The WM_NCLBUTTONDOWN message is posted when the user presses the left mouse button while the cursor is within the 
	;nonclient area of a window. This message is posted to the window that contains the cursor. If a window has captured the 
	;mouse, this message is not posted. 
    .ELSEIF  uMsg == WM_COMMAND
         .ELSEIF  uMsg == WM_CLOSE || uMsg == WM_RBUTTONUP
     
    INVOKE EndDialog, hWnd, 0
    .ENDIF
 

 

    xor eax,eax
  ret
DialogProc endp

end start